/*
 * @(#)src/classes/sov/javax/sound/midi/MetaEventListener.java, audio, as1411, 20040217 1.13.2.1
 * ===========================================================================
 * Licensed Materials - Property of IBM
 * "Restricted Materials of IBM"
 *
 * IBM SDK, Java(tm) 2 Technology Edition, v1.4.1
 * (C) Copyright IBM Corp. 1996, 2002. All Rights Reserved
 * ===========================================================================
 */

/*
 * ===========================================================================
 * Copyright 2002 Sun Microsystems, Inc. All rights reserved.
 * ===========================================================================
 */


/* 
 *
 * Change activity:
 *
 * Reason  Date   Origin    Description
 * ------  ----   ------    -------------------------------------------------- 
 * 14MERG  101201 prussell  Add IBM module header; 
 *
 * ===========================================================================
 *
 *
 *
 * 
 * 
 */

package javax.sound.midi;		  	 

import java.util.EventListener;


/**
 * The <code>MetaEventListener</code> interface should be implemented
 * by classes whose instances need to be notified when a <code>{@link Sequencer}</code> 
 * has processed a <code>{@link MetaMessage}</code>.  
 * To register a <code>MetaEventListener</code> object to receive such 
 * notifications, pass it as the argument to the 
 * <code>{@link Sequencer#addMetaEventListener(MetaEventListener) addMetaEventListener}</code>
 * method of <code>Sequencer</code>.
 *
 * @version 1.12, 00/02/02
 * @author Kara Kytle
 */
public interface MetaEventListener extends EventListener {

	/**
	 * Invoked when a <code>{@link Sequencer}</code> has encountered and processed 
	 * a <code>MetaMessage</code> in the <code>{@link Sequence}</code> it is processing.
	 * @param meta the meta-message that the sequencer encountered 
	 */
	public void meta(MetaMessage meta);
}
